Subject: Re: update 1.76

From: Zheng Gengbin <[email-masked]>
Date: Tue, 8 Apr 1997 17:33:30 +0800 (EAT)

Although we can simplify the defintion of PROCESSORS , but I think
our simplification is too strict to a programmer .
	First (1), a programmer must define a one dimension processor(although
this may be efficient ) , (2) the size of processor must be same .
(3) combine (1) and (2) , that is we allow only one processor definition .
	
	What do you think the difficulty of remove the first restriction ?
As I think , trans0 can support multiple dimension processor definition.
But the it seems a little difficult to detect communication .
And I don't know if Adlib give enough support .

	Also as I understand , we donot intend to do the mapping from
logical processors to physical processors , so the logical processor must
be the same size as physical processors . Am I right?

Zheng

On Mon, 7 Apr 1997, Xiaoming Li wrote:

> 
> For our short term effort, I suggest the
> following simplification on PROCESSORS. 
> 
>    (1) one dimensional processor grid is allowed; as a result,
>        only one processor grid is used in programs. an optional
>        compiler flag is used for specifying the number of processor.
>        Error reported if the two numbers are not equal.
>    (2) There will be no scaler processor arrangement;
>    (3) A non distributed data object is, by default, replicated on
>        every processors.
> 
>    Rationale:
>    (1) Workstation cluster and Beowulfs architectures really have
>        no topological structure that a compiler can exploit to get
>        higher performance; in fact, force programmer to partition
>        his data in one dimension may deliver higher performance than
>        multi-dimensional partitioning in such architectures
>        (relatively high latency).
>    (2) Known HPF programs (HPFA, BH) all use one dimensional processor
>        grid only;
>    (3) One dimensional processor grid makes implementation of some
>        runtime functions easier (probably more efficient), in particular
>        in the case of `array slicing', subprocessor group is either
>        the original group or a single processor.
> 
> ----------
> Xiaoming Li    (315)443-3890 (o)
> NPACT          (315)443-1973 (f)
>